<template>
  <el-dialog
    :title="'退货明细'"
    :close-on-click-modal="false"
    :visible.sync="visible"
  >
    <div class="mod-config">
      <ttable
        :table="table"
        @handleSelectionChange="handleSelectionChange"
        :uploadInfo="uploadInfo"
        :prelang="prelang"
        :options="options"
        :ajaxFun="ajaxFun"
        :paramObj="paramObj"
        :bottomOffset="125"
        ref="sendBackTable"
      >
        <!-- <template #toolbar>
          <el-dropdown @command="handleCommand">
            <el-button>
              状态变更<i class="el-icon-arrow-down el-icon--right"></i>
            </el-button>
            <el-dropdown-menu slot="dropdown">
              <el-dropdown-item
                :command="item.command"
                v-for="item in stateTagArr"
                :disabled="item.disabled"
                >{{ item.label }}</el-dropdown-item
              >
            </el-dropdown-menu>
          </el-dropdown>
        </template> -->
      </ttable>
      <table-form
        v-if="addOrUpdateVisible"
        ref="addOrUpdate"
        @refreshDataList="getData"
      ></table-form>
      <!-- 弹窗, 新增 / 修改 -->
    </div>
  </el-dialog>
</template>

<script>
import ttable from '@/views/common/ztt-table.vue'
import { mapGetters } from 'vuex'
import {
  deleteByIds,
  fetchList,
  updateSendBack
} from '../../../api/warehouse/sendback'
import TableForm from './sendback-form'
export default {
  data() {
    return {
      stateTagArr: [
        // {
        //   label: '确认',
        //   command: 'CONFIRM',
        //   disabled: false,
        //   permitArr: ['01draft']
        // },
        // {
        //   label: '取消',
        //   command: 'CANCEL',
        //   disabled: false,
        //   permitArr: ['02completed']
        // }
      ],
      visible: false,
      paramObj: {},
      innerVisible: false,
      ajaxFun: fetchList,
      multipleSelection: [],
      uploadInfo: {
        // 是否展示上传EXCEL以及对应的url
        isShow: false,
        url: ''
      },
      prelang: 'operation',
      options: {
        height: 300, // 默认高度-为了表头固定
        stripe: true, // 是否为斑马纹 table
        highlightCurrentRow: false, // 是否要高亮当前行
        border: true, // 是否有纵向边框
        lazy: false, // 是否需要懒加载
        fit: true, // 列的宽度是否自撑开
        multiSelect: true, //
        seqNo: true,
        isRefresh: true, // 是否显示刷新按钮
        isShowHide: true, // 是否显示显影按钮
        isSearch: false, // 高级查询按钮
        defaultOrderBy: { column: 'id', direction: 'desc' }
      },
      table: {
        total: 0,
        currentPage: 1,
        pageSize: 20,
        data: [],
        column: [
          {
            minWidth: '140',
            prop: 'escortNo',
            label: '押运单号',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'text'
          },
          // {
          //   minWidth: '120',
          //   prop: 'status',
          //   label: '退货单状态',
          //   sort: true,
          //   isTrue: true,
          //   isSearch: true,
          //   searchInfoType: 'select',
          //   formatter: this.formatStatus,
          //   optList: () => {
          //     return this.statusOptions
          //   }
          // },
          {
            minWidth: '120',
            prop: 'partNo',
            label: '零件编号',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'text'
          },
          {
            minWidth: '120',
            prop: 'partName',
            label: '零件名称',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'text'
          },
          {
            minWidth: '120',
            prop: 'partBatchNo',
            label: '零件批号',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'text'
          },
          {
            minWidth: '120',
            prop: 'systemNo',
            label: '零件系统号',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'text'
          },
          {
            minWidth: '200',
            prop: 'sendBackQuantity',
            label: '退货数量',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'text'
          },
          {
            minWidth: '120',
            prop: 'partUnit',
            label: '零件单位',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'text'
          },
          {
            minWidth: '120',
            prop: 'sendBackDate',
            label: '退货日期',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'datetimerange',
            formatter: this.formatDate
          },
          {
            minWidth: '120',
            prop: 'isCompany',
            label: '是否退回公司',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'text'
          },
          {
            minWidth: '120',
            prop: 'sendBackCompanyDate',
            label: '退回公司日期',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'datetimerange',
            formatter: this.formatDate
          },
          {
            minWidth: '120',
            prop: 'sendBackReason',
            label: '退货原因',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'text'
          },
          {
            minWidth: '120',
            prop: 'sendBackLocationName',
            label: '退货库位',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'text'
          }


          

          
        ],
        toolbar: [
          // {
          //   text: '取消退货',
          //   type: 'primary',
          //   fun: this.sendBack
          // }
        ],
        operator: [
          // {
          //   text: '修改',
          //   type: 'text',
          //   size: 'small',
          //   fun: this.getSendBack
          // }
        ],
        operatorConfig: {
          // fixed: 'right',
          // label: '操作',
          // width: 100,
          // minWidth: 100
        }
      },
      addOrUpdateVisible: false,
      statusOptions: [
        {
          value: '01draft',
          label: '草稿',
          colorLabel: '<span style="color:red">草稿</span>'
        },
        {
          value: '02completed',
          label: '已完成',
          colorLabel: '已完成'
        }
      ]
    }
  },
  components: {
    ttable,
    TableForm
  },
  computed: {
    ...mapGetters(['permissions'])
  },
  methods: {
    // 获取数据列表
    getData() {
      if (this.$refs.sendBackTable !== undefined) {
        this.$refs.sendBackTable.getDataList()
      }
    },
    // table自带事件
    handleSelectionChange(val) {
      // 根据状态，禁用表头按钮
      // 筛选出选中记录的状态
      var stateArr = val.map(function(value, index) {
        return value.status
      })
      // 选中状态数组元素去重
      var uniqueStateArr = []
      for (var i = 0; i < stateArr.length; i++) {
        if (uniqueStateArr.indexOf(stateArr[i]) == -1) {
          uniqueStateArr.push(stateArr[i])
        }
      }
      // 循环自定义按钮，判断每个按钮的permitArr是否完全包含选中状态，若完全包含，则按钮亮，否则按钮灰
      for (var i = 0; i < this.stateTagArr.length; i++) {
        if (
          uniqueStateArr.every((val) =>
            this.stateTagArr[i].permitArr.length <= 0
              ? true
              : this.stateTagArr[i].permitArr.includes(val)
          )
        ) {
          this.stateTagArr[i].disabled = false
        } else {
          this.stateTagArr[i].disabled = true
        }
      }
      this.multipleSelection = val
    },
    formatDate(row, column, cellValue) {
      if (cellValue) {
        const dutyDateList = /\d{4}-\d{1,2}-\d{1,2}/g.exec(cellValue)
        if (dutyDateList && dutyDateList.length > 0) {
          return dutyDateList[0]
        }
      }
      return ''
    },
    sendBack() {
      if (this.multipleSelection && this.multipleSelection.length > 0) {
        deleteByIds(
          this.multipleSelection.map((item) => {
            return item.id
          })
        ).then((response) => {
          var data = response.data
          if (data.code == 0) {
            this.$message.success('删除成功')
            this.getData()
          } else {
            this.$message.error('删除失败')
          }
          this.$emit('refreshDataList')
        })
      } else {
        this.$message.error('请选择删除的对象')
      }
    },
    init(id) {
      if (id) {
        this.paramObj = { escortDetailId: id }
      }
      this.visible = true
      this.$nextTick(() => {
        this.getData()
      })
    },
    handleCommand(event) {
      var eventName
      if (event == 'CONFIRM') {
        eventName = '确认'
      } else {
        eventName = '已取消'
      }
      if (this.multipleSelection && this.multipleSelection.length > 0) {
        updateSendBack(this.multipleSelection, event).then((response) => {
          var data = response.data
          if (data.code == 0) {
            this.$message.success(eventName + '修改成功')
            this.getData()
          } else {
            this.$message.error(eventName + '修改失败')
          }
          this.$emit('refreshDataList')
        })
      } else {
        this.$message.error('请选择' + eventName + '的对象')
      }
    },
    getSendBack(row) {
      this.addOrUpdateVisible = true
      this.$nextTick(() => {
        this.$refs.addOrUpdate.getSendBack(row.id)
      })
    },
    formatStatus(row, column, cellValue) {
      this.statusOptions.forEach((obj) => {
        if (obj.value === cellValue) {
          cellValue = obj.colorLabel
        }
      })
      return cellValue
    }
  }
}
</script>
